% Set property in the specified object.
%
% function retval = set(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function retval = set(self,varargin)
    if (nargin == 1)
        retval = {{{'eqnums'}, {'cell array of equation numbers, each equation array of dimension [m,1]; for symmetric matrices only'}};
            {{'eqnums_row'}, {'cell array of row equation numbers, each an array [m,1]'}};
            {{'eqnums_col'}, {'cell array of column equation numbers, each an array [n,1]'}};
            {{'mat'}, {'cell array of data matrices, each an array [m,n]'}}};
        return;
    end
    prop_name=varargin{1};
    val=varargin{2};
    switch prop_name
        case 'mat'
            self.mat = val;
        case 'eqnums'
            self.eqnums_row = val;
        case 'eqnums_row'
            self.eqnums_row = val;
        case 'eqnums_col'
            self.eqnums_col = val;
        otherwise
            error(['Unknown property ''' prop_name '''!'])
    end
    retval=self; % return self
end
