
function [L0,Lt,Ft]=local_frames(x0,xt)
    % This is the element frame in the configuration t=0. It consists of a
    % single unit vector in the direction of the spring (first node -->
    % second node).
    F0= (x0(2,:)-x0(1,:))'; 
    L0 =norm(F0);
    F0=F0/L0;
    % Compute the first vector of the element frame in configuration t
    F1t= (xt(2,:)-xt(1,:))'; 
    Lt =norm(F1t);
    F1t=F1t/Lt;
    
    % Construct element frame
    if (abs(F1t(3))<0.95)
        F3t=cross(F1t, [0;0;1]);
    else
        F3t=cross(F1t, [1;0;0]);
    end
    F3t=F3t/norm(F3t);
    F2t=cross(F3t, F1t);
    Ft=   [F1t,F2t,F3t];
end