% Compute local normal.
% 
% function norml = normal(self,c,J)
% 
%      self=finite element block
%      c=spatial location
%      J= Jacobian matrix
%      
function norml = normal(self,c,J)
    norml=get(self,'N');
    if isempty(norml)
        error('The block needs to define a normal');
    else
        if  strcmp(class(norml),'function_handle')
            norml= feval(norml, c, J);
        end
    end
end