% Make a new FIELD by taking a slice of another field.
%
% function retobj = slice(fld,idc,name)
%
%   Call as:
%     nf = slice(f, idc, name)
%   where
%     f=field to clone
%     idc = array of indexes of components; the new field consists of the
%     specified components taken out of the nodal parameters of the
%     original field. All attributes are extracted from the original field:
%     subset of the values, equation numbers,is_prescribed attribute, and
%     prescribed_values attribute.
%     name=name of the new field
%
function retobj = slice(self,idc,name)
    retobj=self;
    retobj.name=name;
    retobj.dim  = length(idc);
    retobj.nfens =self.nfens;
    retobj.values =self.values(:,idc);
    retobj.eqnums =self.eqnums(:,idc);
    retobj.is_prescribed = self.is_prescribed(:,idc);
    retobj.prescribed_values = self.prescribed_values(:,idc);
    retobj.neqns = self.neqns;
end

