% Evaluate the basis function matrix for an 27-node brick.
%
% function val = bfun(self,param_coords)
%
%   Call as:
%      N = bfun (g, pc)
%   where
%      g=gcell,
%      pc=parametric coordinates, -1 < pc(j) < 1, length(pc)=3.
%
function val = bfun(self,param_coords)
    %     p(1:4,1:3)= [-1,-1,-1;
    %         1,-1,-1;
    %         1,1,-1;
    %         -1,1,-1];
    %     p(5:8,1:3)= [-1,-1,1;
    %         1,-1,1;
    %         1,1,1;
    %         -1,1,1];
    %     p(9:12,1:3)= [0,-1,-1;
    %         1,0,-1;
    %         0,1,-1;
    %         -1,0,-1];
    %     p(13:16,1:3)= [0,-1,1;
    %         1,0,1;
    %         0,1,1;
    %         -1,0,1];
    %     p(17:20,1:3)= [-1,-1,0;
    %         1,-1,0;
    %         1,1,0;
    %         -1,1,0];
    %     p(21:26,1:3)= [0,0,-1;
    %         0,-1,0;
    %         1,0,0;
    %         0,1,0;
    %         -1,0,0;
    %         0,0,1];
    %     p(27,1:3)= [0,0,0];
    %     idx=[1     2     5     4    10    11    14    13     3     8     6     7    12    17    15    16    19    20    23   22     9    21    26    24    25    18    27];
    %     %         idx=[];
    %     %     for i= 1 : 27
    % %     param_coords=p(i,:);
    %     xi=param_coords(1);
    %     xis = [(xi-1)*xi/2;  (xi+1)*xi/2;  -(xi+1)*(xi-1)];
    %     eta=param_coords(2);
    %     etas = [(eta-1)*eta/2;  (eta+1)*eta/2;  -(eta+1)*(eta-1)];
    %     zeta=param_coords(3);
    %     zetas = [(zeta-1)*zeta/2;  (zeta+1)*zeta/2;  -(zeta+1)*(zeta-1)];
    %     N =zeros(3, 3, 3);
    %     xisetas=(xis*etas');
    %     N(:,:,1)=xisetas*zetas(1);
    %     N(:,:,2)=xisetas*zetas(2);
    %     N(:,:,3)=xisetas*zetas(3);
    %     %     N
    %     %         idx=[idx,find(N==1)]
    %     %     end
    %     val = N(idx)';
    xi=param_coords(1);
    eta=param_coords(2);
    zet=param_coords(3);
    x1 =(xi-1);
    y1=(eta-1);
    z1 =(zet-1);
    x2 =(xi+1);
    y2=(eta+1);
    z2 =(zet+1);
    val =[1/8*z1*zet*x1*xi*y1*eta
        1/8*z1*zet*x2*xi*y1*eta
        1/8*z1*zet*x2*xi*y2*eta
        1/8*z1*zet*x1*xi*y2*eta
        1/8*z2*zet*x1*xi*y1*eta
        1/8*z2*zet*x2*xi*y1*eta
        1/8*z2*zet*x2*xi*y2*eta
        1/8*z2*zet*x1*xi*y2*eta
        1/4*z1*zet*(-x2)*x1*y1*eta
        1/4*z1*zet*x2*xi*(-y2)*y1
        1/4*z1*zet*(-x2)*x1*y2*eta
        1/4*z1*zet*x1*xi*(-y2)*y1
        1/4*z2*zet*(-x2)*x1*y1*eta
        1/4*z2*zet*x2*xi*(-y2)*y1
        1/4*z2*zet*(-x2)*x1*y2*eta
        1/4*z2*zet*x1*xi*(-y2)*y1
        1/4*(-z2)*z1*x1*xi*y1*eta
        1/4*(-z2)*z1*x2*xi*y1*eta
        1/4*(-z2)*z1*x2*xi*y2*eta
        1/4*(-z2)*z1*x1*xi*y2*eta
        1/2*z1*zet*(-x2)*x1*(-y2)*y1
        1/2*(-z2)*z1*(-x2)*x1*y1*eta
        1/2*(-z2)*z1*x2*xi*(-y2)*y1
        1/2*(-z2)*z1*(-x2)*x1*y2*eta
        1/2*(-z2)*z1*x1*xi*(-y2)*y1
        1/2*z2*zet*(-x2)*x1*(-y2)*y1
        (-z2)*z1*(-x2)*x1*(-y2)*y1];
    return;
end

