% Evaluate the basis function matrix for an 4-node line element (bar).
%
% function val = bfun(self,param_coords)
%
%   Call as:
%      N = bfun (g, pc)
%   where
%      g=gcell,
%      pc=parametric coordinates, -1 < pc(j) < 1, length(pc)=3.
%
function val = bfun(self,param_coords)
    xi=param_coords(1);
%  Nodes located at 1:-1, 2:-1/3, 3:1/3, 4:+1
    val=[ (-9/16*(xi)+9/16)*((xi)-1/3)*((xi)+1/3);
        (27/16*(xi)-27/16)*((xi)-1/3)*((xi)+1);
        (-27/16*(xi)+27/16)*((xi)+1/3)*((xi)+1);
        (9/16*(xi)-3/16)*((xi)+1/3)*((xi)+1);
        ];
end

