% Draw marker.
%
% function draw_marker(self, c, princ_dir, radii, context)
%
% required arguments:
% c= coordinates of the center;
% size= marker size;
% context = struct with following optional fields
%    color = color if marker should be drawn in solid color
%
function draw_marker(self, c, context)
dim=length(c);
if dim<3
    c(end+1)=0; 
end
if dim<2
    c(end+1)=0; 
end
c=reshape(c,3,1);
if isfield(context,'color')
    color= context.color;
else
    color='k';
end
if isfield(context,'marker')
    marker= context.marker;
else
    marker='o';
end
if isfield(context,'markersize')
    markersize= context.markersize;
else
    markersize=3;
end
if isfield(context,'linewidth')
    linewidth= context.linewidth;
else
    linewidth=1;
end
line(c(1),c(2),c(3),'linewidth',linewidth,'color',color,'marker',marker,'markersize',markersize);
end

