% Constructor.
%
% function retobj = mater_defor_ss_linviscel_triax (varargin)

% This class represents deformable materials, linear elastic,
% for triaxial strain/stress states, with viscous damping.
% Always takes either zero or one argument.  For no arguments, the default
% object is created.  For one argument, the argument may be either an
% object of the same type, in which case the copy is created; or, it may be
% a struct with the following fields representing parameters.
% Parameters:
%     property = property object
%
function retobj = mater_defor_ss_linviscel_triax (varargin)
    class_name='mater_defor_ss_linviscel_triax';
   if (nargin == 0)
        parent=mater_defor_ss_linel_triax;
        self.property = [];
        retobj = class(self,class_name, parent);
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters =varargin{1};
            parent=mater_defor_ss_linel_triax(Parameters);
            self.property = Parameters.property;
            retobj = class(self,class_name, parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end