% HEAT DIFFUSION EXAMPLES
%
% Files
%   <a href="matlab: edit 'actuator1'">actuator1</a>            - Thermally-driven actuator, thermal analysis
%   <a href="matlab: edit 'actuator1h8'">actuator1h8</a>          - Thermally-driven actuator, H8 elements
%   <a href="matlab: edit 'actuator2'">actuator2</a>            - Thermally-driven actuator, Refined mesh
%   <a href="matlab: edit 'bcSquare'">bcSquare</a>             - Square to test boundary condition application
%   <a href="matlab: edit 'boxgirder1f'">boxgirder1f</a>          - Box girder thermal analysis, with symmetry
%   <a href="matlab: edit 'boxgirder2f'">boxgirder2f</a>          - Box girder thermal analysis, full cross-section
%   <a href="matlab: edit 'ChimneyN'">ChimneyN</a>             - Square  chimney
%   <a href="matlab: edit 'ChimneyN_conv'">ChimneyN_conv</a>       - Square chimney, convergence study
%   <a href="matlab: edit 'CompBlock'">CompBlock</a>            - Composite block 
%   <a href="matlab: edit 'CompBlocktrans'">CompBlocktrans</a>       - Composite block, transient
%   <a href="matlab: edit 'Composite_block'">Composite_block</a>       -  Composite block, steady-state
%   <a href="matlab: edit 'concrete_wall'">concrete_wall</a>        - Concrete wall, 1-D
%   <a href="matlab: edit 'concrete_wall_l3'">concrete_wall_l3</a>     - Concrete wall, 1-D, L3 elements
%   <a href="matlab: edit 'convcyl'">convcyl</a>              - Convergence for an Axially symmetric cylinder
%   <a href="matlab: edit 'convcylflux'">convcylflux</a>          - Display flux for an Axially symmetric cylinder
%   <a href="matlab: edit 'convcylq'">convcylq</a>             - Axially symmetric cylinder, quadratic
%   <a href="matlab: edit 'convcylqad'">convcylqad</a>           - Axially symmetric cylinder, quadratic, adaptive
%   <a href="matlab: edit 'convectioncooled'">convectioncooled</a>     - Convection-cooled domain
%   <a href="matlab: edit 'convectioncooledq'">convectioncooledq</a>    - Convection-cooled domain, quadratic
%   <a href="matlab: edit 'ex60a'">ex60a</a>          - 1-d example
%   <a href="matlab: edit 'helixcooled'">helixcooled</a>          - 3-D helix cooling
%   <a href="matlab: edit 'helixcooled2'">helixcooled2</a>          - 3-D helix cooling, with iso-surfaces
%   <a href="matlab: edit 'hill_decay'">hill_decay</a>          - Smearing out of initial temperature spike
%   <a href="matlab: edit 'Jethava'">Jethava</a>              - Heated block
%   <a href="matlab: edit 'layeredSquare'">layeredSquare</a>         - Layered orthotropic domain
%   <a href="matlab: edit 'lshape1'">lshape1</a>              - L-Shaped domain
%   <a href="matlab: edit 'lshape1q'">lshape1q</a>             - L-Shaped domain
%   <a href="matlab: edit 'lshape2'">lshape2</a>              - L-Shaped domain
%   <a href="matlab: edit 'lshape3'">lshape3</a>              - L-Shaped domain
%   <a href="matlab: edit 'lshape3ad'">lshape3ad</a>            - L-Shaped domain, graded mesh 
%   <a href="matlab: edit 'lshape3_had'">lshape3_had</a>            - L-Shaped domain, h-adaptive computation
%   <a href="matlab: edit 'moving_source'">moving_source</a>        - 3-D plate with moving heat source
%   <a href="matlab: edit 'pnpAnn2'">pnpAnn2</a>             - Annular domain 
%   <a href="matlab: edit 'pnpAnn2Newton'">pnpAnn2Newton</a>        - Annular domain  with Newton's B.C.
%   <a href="matlab: edit 'pnpCircle1'">pnpCircle1</a>           - Circular domain, single element mesh
%   <a href="matlab: edit 'pnpCircle1T6'">pnpCircle1T6</a>         - Circular domain, single T6 element mesh
%   <a href="matlab: edit 'pnpCircle1T6Newton'">pnpCircle1T6Newton</a>   - Circular domain, single T6 element mesh Newton's B.C.
%   <a href="matlab: edit 'pnpCircleT3'">pnpCircleT3</a>   - Circular domain, T3 mesh 
%   <a href="matlab: edit 'pnpDuctNewtonFull'">pnpDuctNewtonFull</a>    - Duct with Newton's B.C., without symmetry
%   <a href="matlab: edit 'pnpDuctNewton1'">pnpDuctNewton1</a>       - Duct with Newton's B.C.,  just a few elements
%   <a href="matlab: edit 'pnpDuctNewton1q4'">pnpDuctNewton1q4</a>       - Duct with Newton's B.C., single element
%   <a href="matlab: edit 'pnpDuctNewtonFull'">pnpDuctNewtonFull</a>  - Duct with Newton's B.C., full geometry
%   <a href="matlab: edit 'pnpDuctNewtonFulldemo'">pnpDuctNewtonFulldemo</a>       - Duct with Newton's B.C., demo
%   <a href="matlab: edit 'pnpDuctNewton_estimation'">pnpDuctNewton_estimation</a>       - Duct with Newton's B.C., error estimation
%   <a href="matlab: edit 'pnpSquare'">pnpSquare</a>            - Square, prescribed temperature, internal heat
%   <a href="matlab: edit 'pnpSquare1'">pnpSquare1</a>           - Square, prescribed temperature, internal heat, four elements
%   <a href="matlab: edit 'pnpSquare1symb'">pnpSquare1symb</a>           - as pnpSquare1 but symbolic
%   <a href="matlab: edit 'pnpSquareNewton'">pnpSquareNewton</a>      - Square,  Newton's B.C., internal heat
%   <a href="matlab: edit 'pnpSquareNewton1'">pnpSquareNewton1</a>     - Square,  Newton's B.C., internal heat, four elements
%   <a href="matlab: edit 'shocking'">shocking</a>             - 1-D. model of a cooling shock; Overshoot
%   <a href="matlab: edit 'shockings'">shockings</a>            - 1-D. model of a cooling shock; Evolution
%   <a href="matlab: edit 'shockingss'">shockingss</a>           - 1-D. model of a cooling shock; Convergence in time
%   <a href="matlab: edit 'shrinkfit'">shrinkfit</a>            - Shrink-fitting
%   <a href="matlab: edit 'shrinkfitad1'">shrinkfitad1</a>         - Shrink-fitting, Uniform mesh
%   <a href="matlab: edit 'shrinkfitad1q'">shrinkfitad1q</a>        - Shrink-fitting, adaptive, quadratic, Heat flux
%   <a href="matlab: edit 'shrinkfitad2'">shrinkfitad2</a>         - Shrink-fitting, graded mesh
%   <a href="matlab: edit 'simple_rectan'">simple_rectan</a>         - Simple rectangle
%   <a href="matlab: edit 'simple_I'">simple_I</a>         - Simple illustration of heat flow/shear stress in torsion analogy
%   <a href="matlab: edit 'SpacerHeatFlow1D'">SpacerHeatFlow1D</a>     - Spacer 1-D (Tutorial)
%   <a href="matlab: edit 'SpacerHeatFlow2D'">SpacerHeatFlow2D</a>     - Spacer (Tutorial)
%   <a href="matlab: edit 'sq1qq'">sq1qq</a>                - Block of two elements, heat flux demo
%   <a href="matlab: edit 'squareinsquare'">squareinsquare</a>       - Block with an insert
%   <a href="matlab: edit 'squareinsquarec'">squareinsquarec</a>      - Block with an insert, contours
%   <a href="matlab: edit 'step_heat_flux_demo'">step_heat_flux_demo</a>  - 1-D domain, step load repeatedly on/off
%   <a href="matlab: edit 't3nafems'">t3nafems</a>             - T3/NAFEMS Benchmark test
%   <a href="matlab: edit 't3nafemsl3'">t3nafemsl3</a>           - T3/NAFEMS Benchmark test, L3 elements
%   <a href="matlab: edit 't4nafems'">t4nafems</a>             - T4/NAFEMS Benchmark test
%   <a href="matlab: edit 't4nafems_conv'">t4nafems_conv</a>        - T4/NAFEMS Benchmark test, convergence, graded
%   <a href="matlab: edit 't4nafems_q4_conv'">t4nafems_q4_conv</a>     - T4/NAFEMS Benchmark test, convergence, Q4 elements
%   <a href="matlab: edit 't4nafems_convu'">t4nafems_convu</a>       - T4/NAFEMS Benchmark test, convergence, Uniform
%   <a href="matlab: edit 't4nafems_t3_had'">t4nafems_t3_had</a>      - T4/NAFEMS Benchmark h-adaptive solution
%   <a href="matlab: edit 't4nafemsq'">t4nafemsq</a>            - T4/NAFEMS Benchmark test, quadratic triangles
%   <a href="matlab: edit 'T129b_l2_uq'">T129b_l2_uq</a>          - Error of L2 elements, uniform load
%   <a href="matlab: edit 'transcool'">transcool</a>            - Transient cooling of a slab
%   <a href="matlab: edit 'two_circles_assembly'">two_circles_assembly</a> - Demonstration of the assembly process
%   <a href="matlab: edit 'two_circles_heat'">two_circles_heat</a>     - Simple domain with a whole
%   <a href="matlab: edit 'underintegr1'">underintegr1</a>     - Example with underintegration of Q4
%   <a href="matlab: edit 'underintegr2'">underintegr2</a>     - Example with underintegration of Q4