kappa=[0.2 0; 0 0.2]; % conductivity matrix
Q=0.015; % uniform heat source
radius=48;
[fens,gcells]=Q4_circle(radius,2,1.0); %    [fens,gcells] = T3_to_Q4(fens,gcells,[]);
    x=get(fens, 'xyz' );
    fens=set(fens, 'xyz',x(:,1:2));
prop=property_diffusion(struct('conductivity',kappa,'source',Q));
mater=mater_diffusion (struct('property',prop));
feb = feblock_diffusion (struct ('mater',mater,...
    'gcells',gcells,...
    'integration_rule',gauss_rule(2,1)));
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
theta=field(struct('name',['theta'], 'dim', 1, 'nfens',...
    get(geom,'nfens')));
fenids=connected_nodes(mesh_bdry(gcells,[]));
fenids=setdiff(fenids,[fenode_select(fens,struct('box',[0 0.99*radius 0 0],...
    'inflate', 0.01*radius)),...
    fenode_select(fens,struct('box',[0 0 0 .99*radius],...
    'inflate', 0.01*radius))]);
prescribed=ones(length(fenids),1);
comp=[];
val=zeros(length(fenids),1);
theta = set_ebc(theta, fenids, prescribed, comp, val);
theta = apply_ebc (theta);
theta = numbereqns (theta);
K = start (sparse_sysmat, get(theta, 'neqns'));
K = assemble (K, conductivity(feb, geom, theta));
F = start (sysvec, get(theta, 'neqns'));
F = assemble (F, source_loads(feb, geom, theta));
theta = scatter_sysvec(theta, get(K,'mat')\get(F,'vec'));
% Plot
gv=graphic_viewer;
gv=reset (gv,[]);
T=get(theta,'values');
dcm=data_colormap(struct('range',[min(T),max(T)],'colormap',jet));
colorfield=field(struct ('name', ['colorfield'], 'data',...
    map_data(dcm, T)));
geomT=field(struct ('name', ['geomT'], ...
    'data',[get(geom,'values'), get(theta,'values')]));
draw(gcells, gv, struct ('x',geomT, 'u',0*geomT,...
    'colorfield',colorfield, 'shrink',1));
draw(gcells, gv, struct ('x',geom, 'u',0*geom, ...
    'facecolor','none'));
% view(2)
