function [h,se]=transviso_trac
E1=0.1; E2=0.4; nu12=0.2; nu23=0.4999; G12=0.07;
convse = 0.005255393835616

W=2;
H=1;
ang=45/360*2*pi;
graphics= ~true;
magn=-0.05;
smult=0;
stabfact=0.;

Meshf=@t3block2d;
    integration_rule = [];
    febf =@feblock_defor_ss_simplex_avg_b;
    styl ='b*-';
%     Meshf=@block2d;
%     integration_rule = gauss_rule(2, 2);
%     febf =@feblock_defor_ss;
%     styl ='gs-';
%     Meshf=@block2d;
%     integration_rule = gauss_rule(2, [1 2]);
%     febf =@feblock_defor_ss_sri;
%     styl ='gs-';
    Meshf=@block2d;
    integration_rule = [];
    febf =@feblock_defor_ss_quad_avg_b;
    styl ='ro-';

h=[];
se=[];
for n=[3, 6, 12, 24]
% for n= [6]
    [fens,gcells] = Meshf(W,H, 2*n, 2*n, 1.0);
    htol=min(W/(2*n),H/(2*n));
    dxy=min(W,H)/n/2/100;
    sxy=smult*dxy;
    rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
    for i=1:length(fens)
        xy=get(fens(i),'xyz');
        if (xy(1)>dxy) & (xy(2)>dxy) & (xy(1)<W-dxy) & (xy(2)<H-dxy)
            xy=[xy(1)+(2*rand(1)-1)/2*sxy,xy(2)+(2*rand(1)-1)/2*sxy];
        end
        fens(i)=set(fens(i),'xyz',xy);
    end
    %     mesh{1}=fens;
    %     mesh{2}=gcells;
    %     drawmesh(mesh); view (2); pause
    % Material
    Prop =property_linel_transv_iso(struct('E1',E1,'E2',E2,'nu12',nu12,'nu23',nu23,'G12',G12,'type', ['strain']));
    mater = mater_defor_ss_linel_biax (struct ('property', Prop,'reduction', ['strain']));
%         D=tangent_moduli (mater, [])
%         [V,N]=eig(D)
    % Finite element block
    feb = febf(struct ('mater',mater, 'gcells',gcells,...
        'integration_rule',integration_rule,...
        'stabfact',stabfact,'Rm',[cos(ang) sin(ang); -sin(ang) cos(ang)]));
    bdry_gcells = mesh_bdry(gcells, struct('other_dimension', 1));
    icl = gcell_select(fens, bdry_gcells, struct('box', [W/4 3*W/4 H H],'inflate',W/1000));
    efebH = feblock_defor_ss (struct ('mater',mater, 'gcells',bdry_gcells(icl),...
        'integration_rule',gauss_rule (1, 2)));
    icl = gcell_select(fens, bdry_gcells, struct('box', [W/4 3*W/4 0 0],'inflate',W/1000));
    efeb0 = feblock_defor_ss (struct ('mater',mater, 'gcells',bdry_gcells(icl),...
        'integration_rule',gauss_rule (1, 2)));
    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero outfunction five
    % Apply EBC's
    % Now the rollers at the bottom
    ebc_fenids=fenode_select (fens,struct('box',[W/2, W/2, H/2, H/2],'inflate',htol/10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+1;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    ebc_fenids=fenode_select (fens,struct('box',[0, 0,H/2,H/2],'inflate',htol/10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+2;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    ebc_fenids=fenode_select (fens,struct('box',[W,W,H/2,H/2],'inflate',htol/10));
    ebc_prescribed=ones(1,length (ebc_fenids));
    ebc_comp=ebc_fenids*0+2;
    ebc_val=ebc_fenids*0;
    u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
    u   = apply_ebc (u);
    % Number equations
    u   = numbereqns (u);
    % Assemble the system matrix
    K = start (sparse_sysmat, get(u, 'neqns'));
    K = assemble (K, stiffness(feb, geom, u));
    K = finish (K);
    % Load
    F = start (sysvec, get(u, 'neqns'));
    fi=force_intensity(struct('magn',[0;+magn]));
F = assemble (F, distrib_loads(efebH, geom, u, fi, 2));
    fi=force_intensity(struct('magn',[0;-magn]));
F = assemble (F, distrib_loads(efeb0, geom, u, fi, 2));
    % Solve
    a = get(K,'mat');
    b = get(F,'vec');
    x = a\b;
    u = scatter_sysvec(u, x);
    disp (['n=' num2str(n) ' Strain energy =' num2str(x'*b/2)])
    h=[h W/n];
    se =[se x'*b/2];

    % Plot
    if graphics
        gv=graphic_viewer;
        gv=reset (gv,struct ('limits',[-0.13*W, 1.13*W,-0.05*H, 1.05*H]));
        set(gca, 'Position',[0.01 0.1 0.82 0.8]);
        scale=1;
        cmap = jet;
        fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
        nvals=get(fld,'values');%min(nvals),max(nvals)
        % nvalsrange=[-0.0001 0.0001];%[min(nvals),max(nvals)]
        nvalsrange=[min(nvals),max(nvals)];
        dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
        colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
        draw(feb,gv, struct ('x', geom, 'u', +scale*u,'colorfield',colorfield, 'shrink',1.0));
        colormap(cmap);
        cbh=colorbar;
        set(cbh,...
            'Position',[0.84 0.15 0.05 0.7],...
            'YLim',[0,1],...
            'YTick',[0,1],...
            'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
        set(get(cbh,'XLabel'),'String','Volumetric strain');
        view (2)
    end
end
if ~graphics
    loglog(h,abs(convse-se)/convse,styl,'lineWIDTH', 3); hold on;
end
end