% The circle circumference consists of two arcs, which are given centers
% slightly offset from the true center of the circle.  The mesh generator
% needs this to make sense of the orientation of the arcs.
h=2;
[fens,gcells,groups,edge_gcells,edge_groups]=targe2_mesher({...
    'curve 1 circle  Center 0 0 radius 7',...
    'curve 2 circle Center -1.5 -2 radius 2',...
    ['subregion 1  property 1 boundary 1 hole -2 '],...
    ['m-ctl-point constant ' num2str(h)]
    }, 1.0);
drawmesh({fens,gcells},'gcells','nodes','shrink', 0.8);
view(2)
geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
xy=get(geom,'values');
z=xy(:,1)*0.2+xy(:,2).*xy(:,1)*0.2+0.01*xy(:,2).^2;
z=xy(:,1)*0; z(33) = 1; 
geom3 = field(struct ('name', ['geom3'],  'data',[xy, 2*z]));
gv=graphic_viewer;
gv=reset (gv,[]);
draw(gcells, gv, struct ('x',geom3, 'u',0*geom3,...
        'facecolor','red','edgecolor','white', 'facealpha',0.5));
    draw(gcells, gv, struct ('x',geom, 'u',0*geom, ...
        'facecolor','none'));
cameratoolbar
lightangle(135,15)
set(gcf,'Renderer','opengl')
set(findobj(gca,'type','surface'),...
    'FaceLighting','flat',...
    'AmbientStrength',.6,'DiffuseStrength',.8,...
    'SpecularStrength',.9,'SpecularExponent',25,...
    'BackFaceLighting','lit')