function f

    function v=kappa_function(T)
        % T<251: (101:25:251),1005*(101:25:251).^(-1.15)
        % T>251 && T<273:16.00.0567  T
%         v = interp1([101   126   151   176   201   226   251 252 273 400],[4.9796    3.8614    3.1358    2.6292    2.2568    1.9722    1.7480 1.7116 0.5209 0.5]*1e-3,T);% 3.6 MJ/m^3/K
        v = interp1([101   400],[0.5 0.5]*1e-3,T);% 3.6 MJ/m^3/K
    end
    kappa=@kappa_function;
    L =300e-3;% 300 MJ/m^3 latent heat
    function v=cp_function(T)
        v = interp1( [0,251,251.1,5000],[0, 0.999, 3.6, 3.6]*1e-3,T);% 3.6 MJ/m^3/K
    end
    cp=@cp_function;
    Width = 60;
    mesh_size=Width/20; 
    Relax =0.95;
    maxit =5;
    dt =10;
    tend =1200;
    Tn1Tol =1e-4;
    penfact = 10000;
    Very_small =1e-30;
    graphics = true; Style ='m-';
    scale = 1;
    Ti = 20+273;
    Tc =Ti;
    Tc_rate = -3;% degrees per second
    Tc_min =-110+273;
    qmagn=-0.1/(2*pi*Width/13);%26 W, that is approximately 1 W/m^1
    Tm1=-22+273; Tm2 =0+273;
    function v=g(T)
        v = interp1([0,Tm1,Tm2,5000],[0,0,1,1],T);
    end

    [fens,gcells, groups,edge_gcells,edge_groups] = targe2_mesher({...
        ['curve 1 line ' num2str(-Width) ' ' num2str(-Width) ' ' num2str(Width) ' ' num2str(-Width) ],...
        ['curve 2 line ' num2str(Width) ' ' num2str(-Width) ' ' num2str(Width) ' ' num2str(Width) ],...
        ['curve 3 line ' num2str(Width) ' ' num2str(Width) ' ' num2str(-Width) ' ' num2str(Width) ],...
        ['curve 4 line ' num2str(-Width) ' ' num2str(Width) ' ' num2str(-Width) ' ' num2str(-Width) ],...
        ['curve 5 circle Center ' num2str(Width/4) ' ' num2str(Width/10) ' radius ' num2str(Width/20) ],...
        ['curve 6 circle Center ' num2str(-Width/4) ' ' num2str(Width/7) ' radius ' num2str(Width/20) ],...
        ['curve 7 circle Center ' num2str(0) ' ' num2str(Width/3) ' radius ' num2str(Width/20) ],...
        ['curve 8 circle Center ' num2str(0) ' ' num2str(0) ' radius ' num2str(Width/13) ],...
        ['subregion 1  property 1 ' ...
        '   boundary 1 2 3 4 hole -5 -6 -7 -8'],...
        ['m-ctl-point constant ' num2str(mesh_size)]
        }, 1.0);
    Dummyprop = property_thermal_diffusion(struct('thermal_conductivity',1.0,...
        'specific_heat',1.0,'source',0));
    mater=mater_diffusion(struct('property',Dummyprop));
    feb = feblock_thermal_nonlinear(struct ('mater',mater,...
        'gcells',gcells,...
        'integration_rule',simplex_nq_rule (2)));
    geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
    tempn=field(struct('name',['tempn'], 'dim', 1, 'nfens',get(geom,'nfens')));
    gL=field(struct('name',['gL'], 'dim', 1, 'nfens',get(geom,'nfens')));
    tempn = tempn +Ti;% initial condition
    tempebc = tempn;% boundary condition
    comp=[];
    Tifenids =[];
    for j=1:4
        eg =edge_groups{j};
        for i=1:length(eg)
            conn =get(edge_gcells(eg(i)),'conn');
            Tifenids = [Tifenids,conn];
        end
    end
    prescribed=ones(length(Tifenids),1);
    val=zeros(length(Tifenids),1)+Ti;%  Ambient
    tempebc = set_ebc(tempebc, Tifenids, prescribed, comp, val);
    Tcfenids =[];
    for j=5:7
        eg =edge_groups{j};
        for i=1:length(eg)
            conn =get(edge_gcells(eg(i)),'conn');
            Tcfenids = [Tcfenids,conn];
        end
    end
    prescribed=ones(length(Tcfenids),1);
    val=zeros(length(Tcfenids),1)+Tc;%  Cold
    tempebc = set_ebc(tempebc, Tcfenids, prescribed, comp, val);
    tempebc = apply_ebc (tempebc);
    tempn = numbereqns (tempn);
    gL = 0*tempn+1;% All liquidus

    efeb = feblock_diffusion (struct ('mater',mater,...
        'gcells',edge_gcells([edge_groups{8}]),...
        'integration_rule',simpson_1_3_rule));

    V = start (sparse_sysmat, get(tempn, 'neqns'));
    V = assemble (V, lumped_volume(feb, geom, tempn));
    NV =get(V,'mat'); clear V


    K = start (sparse_sysmat, get(tempn, 'neqns'));
    tic
    ems=conductivity(feb, geom, tempn);
    toc
    tic
    K = assemble (K, ems);
    toc
    Kt =get(K,'mat'); clear K

    sms =elemat_to_sparse (ems,get(tempn, 'neqns'));

    function assemble_Kt(sms,T)
        KAPPA=kappa(T);
        Kt =Very_small*Kt;
        for j=1:length(sms)
            Kt =Kt +mean(KAPPA(sms{j}.eqnums))*sms{j}.S;
        end
    end
    
    function assemble_Ct(T)
        CP =cp(T);
        Ct =NV;
        for j=1:size(Ct,1)
            Ct(j,j) =NV(j,j)*CP(j);
        end
    end

    if (graphics)
        gv=graphic_viewer;
        gv=reset (gv,[]);
    else
    end

    t= 0; snap=0;
    while t<tend % Time stepping
        disp([' Time ' num2str(t)])
        Tn = gather_sysvec(tempn);
        gLn = gather_sysvec(gL);
        Tn1 =Tn;
        gLn1 =gLn;
        tempn1 =tempn;
        pTn1= gather_sysvec(tempn1);
        %         gLn1 = predict_gL(@g,Tn1,Tn,gLn,L,NV,Ct)
        Ft = start (sysvec, get(tempn, 'neqns'));
        fi= force_intensity(struct('magn',qmagn));
        Ft = assemble (Ft, flux_loads(efeb, geom, tempn1, fi));
        Tc =max( [Ti+t*Tc_rate,Tc_min]);
        prescribed=ones(length(Tcfenids),1);
        val=zeros(length(Tcfenids),1)+Tc;%  Cold
        tempebc = set_ebc(tempebc, Tcfenids, prescribed, comp, val);
        tempebc = apply_ebc (tempebc);
        for i=1:maxit
            r=phase_change_source(gLn1,gLn,dt,L,NV);
            assemble_Ct(Tn1);
            assemble_Kt(sms,Tn1);
            [Ktebc,Febc]=penalty_ebc(Kt,get(Ft,'vec'),tempebc,tempn1,penfact);
            Tn1=(Ct/dt+Ktebc)\((Ct*Tn)/dt+Febc+r);
            gLn1 = update_gL(@g,gLn1,Tn1,Tm1,Tm2,L,NV,Ct,dt,Relax);
            tempn1 = scatter_sysvec(tempn1, Tn1);
            nT=norm(Tn1-pTn1,Inf);
            disp([' Iteration ' num2str(i) ', norm(Tn1-pTn1)=' num2str(nT)]);
            if (nT<Tn1Tol)
                break;
            end
            pTn1 =Tn1;
        end
        pCt =Ct;
        t=t+dt;
        tempn =tempn1;
        gLn =gLn1;
        gL =scatter_sysvec(gL, gLn1);
        snap=snap+1;
        if (graphics && (mod(snap,10)==1))
            gv=reset (gv,[]);
            
%             T=get(gL,'values');
%             XY=get(geom,'values');
%             conn=zeros(length (gcells),3);
%             for i=1:length (gcells)
%                 conn(i,:)= get(gcells(i),'conn');
%             end
%             for i=1:length (gcells)
%                 draw(gcells(i), gv, struct ('x',geom, 'u',0*geom, 'facecolor','none','edgecolor',[0.49, 0.49, 0.49]));
%             end
% 
%             tricontour(XY,conn,T,15)
%             view(2)
            
            Values=get(tempn1,'values')-273;
            Range =[-2,max(Values)];
                       Values=get(gL,'values');
            Range =[0,1];
            dcm=data_colormap(struct ('range',Range, 'colormap',jet(9)));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, Values)));
            geomT=field(struct ('name', ['geomT'], ...
                'data',[get(geom,'values'), scale*Values]));
            draw(feb, gv, struct ('x',geomT, 'u',0*geomT,...
                'colorfield',colorfield, 'shrink',1));
            %             draw(feb, gv, struct ('x',geom, 'u',0*geom,
            %             'facecolor','none'));
            camset(gv, [-515.2936 -788.4261  958.0761   -5.5125   11.7699  -24.4181         0         0    1.0000    4.5466]);
                        camset(gv, [-0.1151    0.1151  846.9261   -0.1151    0.1151    0.0250         0    1.0000         0    8.0894]);
            drawnow
        else
        end

    end

end

function gLn1 = update_gL(g,gLn1,Tn1,Tm1,Tm2,L,NV,Ct,dt,Relax)
    for j=1:length(Tn1)
        if (gLn1(j)>0) && (gLn1(j)<1)
            Tn1g =Tm1 +gLn1(j)*(Tm2-Tm1);
        elseif (gLn1(j)<=0)
            Tn1g =Tm1;
        else
            Tn1g =Tm2;
        end
        gLn1(j) = gLn1(j) + (Relax)*Ct(j,j)/L/NV(j,j)*(Tn1(j)-Tn1g);
        if (gLn1(j)<0) gLn1(j)=0;end
        if (gLn1(j)>1) gLn1(j)=1;end
    end
end

function v = phase_change_source(gLn1,gLn,dt,L,NV)
    v=0*gLn1;
    for j=1:length(gLn1)
        v(j) =-L*(gLn1(j)-gLn(j))/dt*NV(j,j);
    end
end
