% Mesh of a orthogonal block, unstructured, obtained by splitting of tetrahedra.
%
% function [fens,gcells] = H8_block_u(Length,Width,Height,nL,nW,nH)
%
% Mesh of a block located in a given range, H20 cells
% <0,Length> x <0,Width> x <0,Height>
% Divided into elements: nL, nW, nH in the first, second, and
% third direction (x,y,z). H8 elements obtained by subdividing tetrahedra.
function [fens,gcells] = H8_block_u(Length,Width,Height,nL,nW,nH)
    nL=max([round(nL/2),1]);
    nW=max([round(nW/2),1]);
    nH=max([round(nH/2),1]);
    [fens,gcells] = T4_block(Length,Width,Height,nL,nW,nH);
    [fens,gcells] = T4_to_H8(fens,gcells);
end
