% Mesh of a line segment located in a given range, L2 Elements
%
% function [fens,gcells] = L2_block(Length,nL,options)
%
% Interval x=<0,Length>
% Divided into nL elements of the L2 type.
function [fens,gcells] = L2_block(Length,nL,options)
    nnodes=(nL+1);
    xs=zeros(nnodes,1);
    ncells=(nL);
    conns=zeros(ncells,2);

    if ~isstruct(options)
        if (isempty(options))
            options=1.0;
        end
        options= struct('other_dimension',options);
    end

    f=1;
    for i=1:(nL+1)
         xs(f,:)=[(i-1)*Length/nL];
        f=f+1;
    end

    gc=1;
    for i=1:nL
        conns(gc,:)=[i,i+1];
        gc=gc+1;
    end
    fens=fenodeset(struct('id',(1:nnodes)','xyz',xs));
    options.conn=conns;
    gcells =gcellset_L2(options);
end
