% Refine a mesh of quadrilaterals by division into  five interior
% quadrilaterals
%
% function [fens,gcells] = Q4_refine_5(fens,gcells)
%
function [fens,gcells] = Q4_refine_5(fens,gcells)
    nsubcells=5;
    conns=get(gcells,'conn');
    xyz =get(fens,'xyz');
    nfens=size(xyz,1);
    nifens=4*count(gcells);% number of internal nodes
    xyz=[xyz;zeros(nifens,size(xyz,2))];
    % construct new geometry cells
    nconns =zeros(nsubcells*count(gcells),4);
    nc=1;
    for i= 1:count(gcells)
        xyzm=mean(xyz(conns(i,:),:));
        inn=nfens+(i-1)*4+(1:4);
        xyz(inn(1),:)=mean([xyzm;xyz(conns(i,1),:)]);
        xyz(inn(2),:)=mean([xyzm;xyz(conns(i,2),:)]);
        xyz(inn(3),:)=mean([xyzm;xyz(conns(i,3),:)]);
        xyz(inn(4),:)=mean([xyzm;xyz(conns(i,4),:)]);
        nconns(nc,:) =[conns(i,1) conns(i,2) inn(2) inn(1)];
        nc= nc+ 1;
        nconns(nc,:) =[conns(i,2) conns(i,3) inn(3) inn(2)];
        nc= nc+ 1;
        nconns(nc,:) =[conns(i,3) conns(i,4) inn(4) inn(3)];
        nc= nc+ 1;
        nconns(nc,:) =[conns(i,4) conns(i,1) inn(1) inn(4)];
        nc= nc+ 1;
        nconns(nc,:) =inn;
        nc= nc+ 1;
    end
    Thickness =get(gcells,'other_dimension');
    gcells =gcellset_Q4(struct('id',1:nc-1,'conn',nconns,...
        'other_dimension',Thickness));
    fens =fenodeset(struct('id',1:size(xyz,1),'xyz',xyz));
end
