% Mesh of a set of springs given by the location of the
% nodes and a list of which nodes are connected by springs.
%
% function [fens,gcells] = Beam_member(xyz,nL,constructor,Parameters)
%
% xyz = M rows, one vertex location per row;
% conn = Connectivities array
% Parameters= see gcellset_L2
% 
function [fens,gcells] = Springs(xyz,conn,Parameters)
    nnodes=size(xyz,1);
    fens=fenodeset(struct('id',(1:nnodes)','xyz',xyz));
    Parameters.conn=conn;
    gcells =gcellset_L2(Parameters);
end
