% Import tetrahedral (4- and 10-node) Comsol Mesh.
%
% function [fens,gcells]=Comsol_mesh_import(filename,xyzscale,saveReadData)
%
% limitations: only the node and solid-element sections are read. Only 4-node and 10-node
% tetrahedra  are handled.
function [fens,gcells]=native_mesh_import(filename,xyzscale,saveReadData)
    
% Always ignore    
    xyzscale = 1.0;
    
% Always ignore    
    saveReadData = ~true;
    
    [pathstr, name, ext] = fileparts(filename) ;
    if (isempty(pathstr)),pathstr ='.';end
    saveFile = [pathstr filesep name ,'_xyzconn' '.mat'];
    
    data=load(filename);
    
     % Create output arguments. First the nodes
    clear fens
    fens=data.fens;
    
    % Now the geometric cells for each element set
    clear gcells
    gcells=data.gcells;
end
 
