% Create  cell array of commands that define curves for triangulation of a
% domain given as an array of vertices. 
%
% function Commands =  targe2_mesher_vl_cmds(v)
%
% Create a uniform triangulation of the domain given as an array of vertex
% coordinates, v, one row per vertex. The vertices needs to be supplied in
% counterclockwise order. 
% 
% Input: The same as for targe2_mesher().
% varargin-- optional argument: structure with name-value pairs
% In addition to the attributes recognized by targe2_mesher(), one can
% specify the uniform mesh size
%                - mesh_size:  mesh size.
% Output: The same as for targe2_mesher().
%
function Commands =  targe2_mesher_vl_cmds(v)
    nv =length(v);
    minSide=Inf;
    for i= 1:nv
        Commands{i}=sprintf('curve %d line %g %g %g %g\n',i,v(i,1),v(i,2),v(mod(i,nv)+1,1),v(mod(i,nv)+1,2));
        minSide=min([minSide,norm(v(i,:)-v(mod(i,nv)+1,:))]);
    end
end
